; CONSOLE #
include win64a.inc
MAXSCREENX = 80
MAXSCREENY = 25
MEM_SIZE   = 65535
.code
WinMain proc
local hFile:qword
local szReadWrite:qword
local FileSize:qword    
local hHeap:qword
local pMem:qword
local ConsoleWindow:SMALL_RECT
local cci:CONSOLE_CURSOR_INFO
local MOUSE_KEY:INPUT_RECORD
 
        
        invoke	FreeConsole
        invoke  AllocConsole
        invoke  GetStdHandle,STD_INPUT_HANDLE
        mov     hIn,rax
        invoke  GetStdHandle,STD_OUTPUT_HANDLE
        mov     hOut,rax
        invoke    GetLargestConsoleWindowSize,eax
;   eax return in 31-16 bits: dwCoord.y
;                 15-00 bits: dwCoord.x
 
        lea 	r8d,ConsoleWindow       ; lpConsoleWindow
    	and 	dword ptr [r8],0
;   lpConsoleWindow.Left = 0 lpConsoleWindow.Top = 0
 
    	sub 	ax, MAXSCREENX
    	sbb 	edx, edx
    	and 	ax, dx
    	add 	ax, MAXSCREENX-1
    	mov 	[r8+SMALL_RECT.Right],ax
 
    	shr 	eax, 16
    	sub 	eax, MAXSCREENY
    	sbb 	edx, edx
    	and 	eax, edx
    	add 	eax, MAXSCREENY-1
    	mov 	[r8+SMALL_RECT.Bottom],ax
 
    	invoke  SetConsoleWindowInfo,hOut,TRUE
        invoke  SetConsoleTitle,&Str1
;hide cursor----------------------------------------
    	invoke  GetConsoleCursorInfo,hOut,&cci
        lea 	edx,cci             ; lpConsoleCursorInfo
    	mov 	[rdx+CONSOLE_CURSOR_INFO.bVisible],ebx;FALSE
    	invoke  SetConsoleCursorInfo,hOut
;------------------------------------------------------
    	invoke  CreateFile,&filename,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,0,0      ;to open the file
    	inc     eax;cmp eax,-1
    	jz      EXIT
    	dec     eax
    	mov 	hFile,rax
    	invoke  GetFileSize,rax,0
    	mov 	FileSize,rax
    	invoke  GetProcessHeap
    	mov 	hHeap,rax
        invoke  RtlAllocateHeap,rax,HEAP_ZERO_MEMORY,MEM_SIZE
    	mov     pMem,rax
    	invoke  ReadFile,hFile,rax,FileSize,&szReadWrite,0        ;to read in the buffer
    	invoke  WriteConsole,hOut,pMem,FileSize,&szReadWrite,0        ;to bring buffer contents to the console
    	invoke  CloseHandle,hFile     ;to close the file
        invoke  HeapFree,hHeap,0,pMem
;--------------------------------------------------------
    	invoke  WriteConsole,hOut,&Str2,sizeof Str2,&szReadWrite,0        ;to bring Str2 to the console
;--------------------------------------------------------
@@:     invoke  ReadConsoleInput,hIn,&MOUSE_KEY,1,&szReadWrite
        lea     eax,MOUSE_KEY
    	cmp     [rax+INPUT_RECORD.EventType],MOUSE_EVENT
    	je  	@b
    	cmp     [rax+INPUT_RECORD.EventType],KEY_EVENT
    	jne     @b
    	cmp     [rax+INPUT_RECORD.KeyEvent.wVirtualKeyCode],VK_ESCAPE
    	jne     @b
EXIT:   invoke  FreeConsole
    	invoke	RtlExitUserProcess,NULL
WinMain endp
hIn	dq ?
hOut	dq ?
Str1 db 'Memory Management, File I/O, GetProcessHeap, HeapAlloc and HeapFree',0
Str2 db 13,10,'For exit press ESC or CTRL+C or CTRL+Break'
filename db '15.asm',0
end